/*
 * This file is generated by jOOQ.
*/
package cc.cinnamon.canary.users.model.tables.pojos


import cc.cinnamon.canary.users.model.tables.interfaces.IRolesPermissions

import javax.annotation.Generated
import javax.validation.constraints.NotNull


/**
 * This class is generated by jOOQ.
 */
@Generated(value = *arrayOf("http://www.jooq.org", "jOOQ version:3.9.1", "schema version:public_4"), date = "2017-02-20T21:56:50.783Z", comments = "This class is generated by jOOQ")
class RolesPermissions : IRolesPermissions {

    override var id: Long? = null
    @get:NotNull
    override var roleId: Long? = null
    @get:NotNull
    override var permissionId: Long? = null

    constructor() {}

    constructor(value: RolesPermissions) {
        this.id = value.id
        this.roleId = value.roleId
        this.permissionId = value.permissionId
    }

    constructor(
            id: Long?,
            roleId: Long?,
            permissionId: Long?
    ) {
        this.id = id
        this.roleId = roleId
        this.permissionId = permissionId
    }

    override fun equals(obj: Any?): Boolean {
        if (this === obj)
            return true
        if (obj == null)
            return false
        if (javaClass != obj.javaClass)
            return false
        val other = obj as RolesPermissions?
        if (id == null) {
            if (other!!.id != null)
                return false
        } else if (id != other!!.id)
            return false
        if (roleId == null) {
            if (other.roleId != null)
                return false
        } else if (roleId != other.roleId)
            return false
        if (permissionId == null) {
            if (other.permissionId != null)
                return false
        } else if (permissionId != other.permissionId)
            return false
        return true
    }

    override fun hashCode(): Int {
        val prime = 31
        var result = 1
        result = prime * result + if (id == null) 0 else id!!.hashCode()
        result = prime * result + if (roleId == null) 0 else roleId!!.hashCode()
        result = prime * result + if (permissionId == null) 0 else permissionId!!.hashCode()
        return result
    }

    override fun toString(): String {
        val sb = StringBuilder("RolesPermissions (")

        sb.append(id)
        sb.append(", ").append(roleId)
        sb.append(", ").append(permissionId)

        sb.append(")")
        return sb.toString()
    }

    // -------------------------------------------------------------------------
    // FROM and INTO
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    override fun from(from: IRolesPermissions) {
        id = from.id
        roleId = from.roleId
        permissionId = from.permissionId
    }

    /**
     * {@inheritDoc}
     */
    override fun <E : IRolesPermissions> into(into: E): E {
        into.from(this)
        return into
    }

    companion object {

        private val serialVersionUID: Long = -86877472
    }
}
